VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DQHelper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private pbErrText As PropertyBag
Public Function GetRCText(rc As Long) As String

   On Error GoTo NoRcText
   GetRCText = pbErrText.ReadProperty(Format(rc, "####"))
   Exit Function
NoRcText:
   GetRCText = "Unknown return code.  Check the toolkit header files."

End Function


Private Sub Class_Initialize()
   Set pbErrText = New PropertyBag
   rc = 6000      'CWBDQ_START
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid attributes handle: CWBDQ_INVALID_ATTRIBUTE_HANDLE"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid data handle: " & _
                        "CWBDQ_INVALID_DATA_HANDLE      CWBDQ_START+1"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid queue handle : " & _
                       "CWBDQ_INVALID_QUEUE_HANDLE     CWBDQ_START+2"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid data queue read handle: " & _
                       "CWBDQ_INVALID_READ_HANDLE      CWBDQ_START+3"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid maximum record length for a data queue: " & _
                       "CWBDQ_INVALID_QUEUE_LENGTH     CWBDQ_START+4"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid key length: " & _
                       "CWBDQ_INVALID_KEY_LENGTH       CWBDQ_START+5"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid queue order                       : " & _
                       "CWBDQ_INVALID_ORDER            CWBDQ_START+6"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid queue authority                   : " & _
                       "CWBDQ_INVALID_AUTHORITY        CWBDQ_START+7"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Queue title (description) is too long or cannot be converted: " & _
                       "CWBDQ_INVALID_QUEUE_TITLE      CWBDQ_START+8"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Queue name is too long or cannot be converted: " & _
                       "CWBDQ_BAD_QUEUE_NAME           CWBDQ_START+9"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Library name is too long or cannot be converted  " & _
                       "CWBDQ_BAD_LIBRARY_NAME         CWBDQ_START+10"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "System name is too long or cannot be converted " & _
                       "CWBDQ_BAD_SYSTEM_NAME          CWBDQ_START+11"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Length of key is not correct for this data queue " & _
                        "or key length is greater than 0 for a LIFO or FIFO data queue " & _
                       "CWBDQ_BAD_KEY_LENGTH           CWBDQ_START+12"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Length of data is not correct for this data queue.  Either the " & _
                        "data length is zero or it is greater than the maximum allowed " & _
                        "of 31744 bytes.  " & _
                        "CWBDQ_BAD_DATA_LENGTH          CWBDQ_START+13"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Wait time is not correct                  : " & _
                        "CWBDQ_INVALID_TIME             CWBDQ_START+14"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Search order is not correct               : " & _
                        "CWBDQ_INVALID_SEARCH           CWBDQ_START+15"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Returned data was truncated               : " & _
                        "CWBDQ_DATA_TRUNCATED           CWBDQ_START+16"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Wait time has expired and no data has been returned " & _
                        "CWBDQ_TIMED_OUT                CWBDQ_START+17"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Command rejected by user exit program     : " & _
                       "CWBDQ_REJECTED_USER_EXIT       CWBDQ_START+18"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Error in user exit program or invalid number of exit programs " & _
                       "CWBDQ_USER_EXIT_ERROR          CWBDQ_START+19"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Library not found on system               : " & _
                       "CWBDQ_LIBRARY_NOT_FOUND        CWBDQ_START+20"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Queue not found on system                 : " & _
                       "CWBDQ_QUEUE_NOT_FOUND          CWBDQ_START+21"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "No authority to library or data queue     : " & _
                       "CWBDQ_NO_AUTHORITY             CWBDQ_START+22"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Data queue is in an unusable state        : " & _
                       "CWBDQ_DAMAGED_QUEUE            CWBDQ_START+23"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Data queue already exists                 : " & _
                       "CWBDQ_QUEUE_EXISTS             CWBDQ_START+24"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Invalid message length - exceeds queue maximum record length " & _
                       "CWBDQ_INVALID_MESSAGE_LENGTH   CWBDQ_START+25"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Queue destroyed while waiting to read or peek a record " & _
                        "CWBDQ_QUEUE_DESTROYED          CWBDQ_START+26"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "No data was received                      : " & _
                        "CWBDQ_NO_DATA                  CWBDQ_START+27"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Data cannot be converted for this data queue.  The data queue " & _
                        "can be used but data cannot be converted between ASCII and " & _
                        "EBCDIC.  The convert flag on the data object will be ignored.  " & _
                       "CWBDQ_CANNOT_CONVERT           CWBDQ_START+28"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Syntax of the data queue name is incorrect.  Queue name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric  " & _
                        "CWBDQ_QUEUE_SYNTAX             CWBDQ_START+29"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Syntax of the library name is incorrect.  Library name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric. " & _
                        "CWBDQ_LIBRARY_SYNTAX           CWBDQ_START+30"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Address not set.  The data object was not set with with " & _
                        "cwbDQ_SetDataAddr(), so the address cannot be retrieved.  " & _
                        "Use cwbDQ_GetData() instead of cwbDQ_GetDataAddr()." & _
                       "CWBDQ_ADDRESS_NOT_SET     CWBDQ_START+31"
   rc = rc + 1
   
   pbErrText.WriteProperty Format(rc, "####"), "Host error occurred for which no return is defined.  " & _
                        "See the error handle for the message text. " & _
                        "CWBDQ_HOST_ERROR          CWBDQ_START+32"
   rc = rc + 1
   
   
   rc = 6099
   pbErrText.WriteProperty Format(rc, "####"), "Unexpected error                        : " & _
                        "CWBDQ_UNEXPECTED_ERROR    CWBDQ_START+99"


End Sub
