VERSION 5.00
Begin VB.Form dqAttrs 
   Caption         =   "Data Queue Attributes"
   ClientHeight    =   3210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3930
   LinkTopic       =   "Form1"
   ScaleHeight     =   3210
   ScaleWidth      =   3930
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton okBtn 
      Caption         =   "OK"
      Height          =   315
      Left            =   1320
      TabIndex        =   6
      Top             =   2760
      Width           =   1095
   End
   Begin VB.Label txtKeyLen 
      Caption         =   "Key Length:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2400
      Visible         =   0   'False
      Width           =   3735
   End
   Begin VB.Label dqForceWrite 
      Caption         =   "Force writes to storage:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   3615
   End
   Begin VB.Label dqSenderInfo 
      Caption         =   "Sender information saved:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   3615
   End
   Begin VB.Label dqMaxLength 
      Caption         =   "Maximum record length:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   3615
   End
   Begin VB.Label dqRtvOrder 
      Caption         =   "Retrieval Order:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   3615
   End
   Begin VB.Label dqDesc 
      Caption         =   "Description:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   3615
   End
   Begin VB.Label dqName 
      Caption         =   "Data queue name:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   3615
   End
End
Attribute VB_Name = "dqAttrs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public dq As Object

' This routine uses the DataQueue and DataQueueAtrributes objects to
' retrieve inforamation (attributes) about an AS/400 data queue

Private Sub Form_Load()
  Dim dqa As cwbx.DataQueueAttributes
  Dim rtvType(2) As String

  On Error GoTo failed

  rtvType(0) = "LIFO"
  rtvType(1) = "FIFO"
  rtvType(2) = "KEYED"

  ' Retrieve the attributes of the queue
  Screen.MousePointer = vbHourglass
  Debug.Print TypeName(dq)
  Set dqa = dq.QueryAttributes
  Screen.MousePointer = vbDefault

  ' Display the retrieved attribute values
   dqName.Caption = "Data queue name:  " & dq.QueueName
   dqDesc.Caption = "Description:  " & dqa.Description
   dqForceWrite.Caption = "Force writes to storage:  " & dqa.ForceWritesToStorage
   dqMaxLength.Caption = "Maximum record length:  " & dqa.MaxRecordLength
   dqRtvOrder.Caption = "Retrieval order:  " & rtvType(dqa.RetrievalOrder)
   dqSenderInfo.Caption = "Sender information saved:  " & dqa.SenderInfoSaved
   If StrComp(TypeName(dq), "IcwbxKeyedDataQueue", vbTextCompare) = 0 Then
      txtKeyLen.Caption = "Key length: " & dqa.KeySize
      txtKeyLen.Visible = True
   Else
      txtKeyLen.Visible = False
   End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.dq.Errors
  errInfo.Show vbModal
End Sub

' This routine terminates the dialog
Private Sub okBtn_Click()
  Unload Me
End Sub


