VERSION 5.00
Begin VB.Form vballobj 
   Caption         =   "Visual Basic sample for Express ActiveX automation objects"
   ClientHeight    =   7755
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   6945
   LinkTopic       =   "Form1"
   ScaleHeight     =   7755
   ScaleWidth      =   6945
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox libName 
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   2655
   End
   Begin VB.CommandButton crtLib 
      Caption         =   "Create Library"
      Height          =   315
      Left            =   5160
      TabIndex        =   4
      Top             =   1080
      Width           =   1625
   End
   Begin VB.CommandButton browseLibs 
      Caption         =   "Browse..."
      Height          =   315
      Left            =   2880
      TabIndex        =   3
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton retrieveSysInfo 
      Caption         =   "Retrieve System Info"
      Height          =   315
      Left            =   5160
      TabIndex        =   1
      Top             =   360
      Width           =   1625
   End
   Begin VB.ComboBox sysNames 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3975
   End
   Begin VB.CommandButton aboutExpress 
      Caption         =   "About Client Access Express"
      Height          =   315
      Left            =   4200
      TabIndex        =   14
      Top             =   7440
      Width           =   2655
   End
   Begin VB.CommandButton dltLib 
      Caption         =   "Delete Library"
      Height          =   315
      Left            =   5160
      TabIndex        =   5
      Top             =   1440
      Width           =   1625
   End
   Begin VB.Frame Frame3 
      Caption         =   "AS/400 data queue "
      Height          =   4935
      Left            =   120
      TabIndex        =   18
      Top             =   1920
      Width           =   6735
      Begin VB.Frame Keyed 
         Caption         =   "Key Info "
         Height          =   855
         Left            =   120
         TabIndex        =   22
         Top             =   240
         Width           =   6495
         Begin VB.TextBox txtKeyData 
            Enabled         =   0   'False
            Height          =   285
            Left            =   2520
            TabIndex        =   24
            Text            =   "Ex:  ""abc"" or ""0x01 0x02"""
            Top             =   480
            Width           =   3855
         End
         Begin VB.CheckBox chkUseKeyed 
            Caption         =   "Use Keyed Data Queue"
            Height          =   255
            Left            =   120
            TabIndex        =   23
            Top             =   240
            Width           =   2295
         End
         Begin VB.Label lblKeyData 
            Caption         =   "Enter Key as Text or Hex (0x00).  Use exact length:"
            Height          =   255
            Left            =   2520
            TabIndex        =   25
            Top             =   240
            Width           =   3855
         End
      End
      Begin VB.TextBox dqName 
         Height          =   315
         Left            =   120
         TabIndex        =   6
         Top             =   1440
         Width           =   2535
      End
      Begin VB.CommandButton browseDQ 
         Caption         =   "Browse..."
         Height          =   315
         Left            =   2760
         TabIndex        =   7
         Top             =   1440
         Width           =   1215
      End
      Begin VB.CommandButton crtDQ 
         Caption         =   "Create Queue..."
         Height          =   315
         Left            =   5040
         TabIndex        =   8
         Top             =   1320
         Width           =   1625
      End
      Begin VB.CommandButton dltDQ 
         Caption         =   "Delete Queue"
         Height          =   315
         Left            =   5040
         TabIndex        =   9
         Top             =   1680
         Width           =   1625
      End
      Begin VB.CommandButton dqAttributes 
         Caption         =   "Queue Attributes"
         Height          =   315
         Left            =   5040
         TabIndex        =   10
         Top             =   2040
         Width           =   1625
      End
      Begin VB.CommandButton receive 
         Caption         =   "Receive"
         Height          =   315
         Left            =   5690
         TabIndex        =   13
         Top             =   3720
         Width           =   975
      End
      Begin VB.TextBox receiveData 
         Enabled         =   0   'False
         Height          =   975
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   15
         TabStop         =   0   'False
         Top             =   3720
         Width           =   5415
      End
      Begin VB.TextBox sendData 
         Height          =   855
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   11
         Top             =   2520
         Width           =   5415
      End
      Begin VB.CommandButton send 
         Caption         =   "Send"
         Height          =   315
         Left            =   5690
         TabIndex        =   12
         Top             =   2520
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "Data queue:"
         Height          =   315
         Left            =   120
         TabIndex        =   21
         Top             =   1200
         Width           =   3375
      End
      Begin VB.Label Label3 
         Caption         =   "Data to send to the queue:"
         Height          =   255
         Left            =   120
         TabIndex        =   20
         Top             =   2280
         Width           =   2895
      End
      Begin VB.Label Label4 
         Caption         =   "Data received from the queue:"
         Height          =   255
         Left            =   120
         TabIndex        =   19
         Top             =   3480
         Width           =   4695
      End
   End
   Begin VB.Label Label6 
      Caption         =   "New or existing AS/400 system:"
      Height          =   315
      Left            =   120
      TabIndex        =   16
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label Label1 
      Caption         =   "Library:"
      Height          =   315
      Left            =   120
      TabIndex        =   17
      Top             =   840
      Width           =   1695
   End
End
Attribute VB_Name = "vballobj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' Declare global objects to use throughout the application
Public as400 As New cwbx.AS400System
Public dq As New cwbx.DataQueue
Public kdq As New cwbx.KeyedDataQueue
Public pgm As New cwbx.Program
Public cmd As New cwbx.Command
Public gDQHelper As New DQHelper    'DQ return code assistance

' Global variables used for retrieving AS/400 object lists
Public listType As String
Public userSpaceCreated As Boolean

' This routine brings up a dialog to display Client Access version
' information and information about which components are installed.
' The ClientInfo object is used to retrieve this information.
Private Sub aboutExpress_Click()
  aboutExp.Show vbModal
End Sub

' This routine invokes a dialog to display the list of data queues
' contained in an AS/400 library.  The Program object is used to
' call an AS/400 system API (QUSLOBJ), in order to retrieve the list
Private Sub browseDQ_Click()
  Dim listRetrieved As Boolean

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus

  Else
    listType = "Queues"

    ' Retrieve all objects in the library of type data queue
    Screen.MousePointer = vbHourglass
    listRetrieved = browse.RetrieveObjects("*ALL", UCase(libName.Text), "*DTAQ")
    Screen.MousePointer = vbDefault

    ' If the list was successfully retrieved, display a dialog with
    ' the results
    If (listRetrieved = True) Then
      browse.Show vbModal
    End If
  End If
End Sub

' This routine invokes a dialog to display the list of user libraries
' contained on an AS/400 system.  The Program object is used to
' call an AS/400 system API (QUSLOBJ), in order to retrieve the list
Private Sub browseLibs_Click()
  Dim listRetrieved As Boolean

  ' Validate input value
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus

  Else
    listType = "Libraries"

    ' Retrieve all user libries contained in QSYS
    Screen.MousePointer = vbHourglass
    listRetrieved = browse.RetrieveObjects("*ALLUSR", "QSYS", "*LIB")
    Screen.MousePointer = vbDefault

    ' If the list was successfully retrieved, display a dialog with
    ' the results
    If (listRetrieved = True) Then
      browse.Show vbModal
    End If
  End If
End Sub

Private Sub chkUseKeyed_Click()
   If chkUseKeyed.Value = vbChecked Then
      
      txtKeyData.Enabled = True
   Else
      
      txtKeyData.Enabled = False
   End If
End Sub

' This routine brings up a dialog which allows you to set the attributes
' of a data queue and then create it.  The DataQueueAttributes and
' DataQueue objects are used to retrieve this information.
Private Sub crtDQ_Click()
  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus
  ElseIf (dqName.Text = "") Then
    MsgBox "Enter a queue name"
    dqName.SetFocus

  ' Display a dialog for creating the data queue
  Else
      If chkUseKeyed.Value = vbChecked Then
         createQ.IsKeyedDQ = True
      Else
         createQ.IsKeyedDQ = False
      End If
      createQ.Show vbModal
  End If
End Sub

' This routine uses the Command object to create a new library on
' the AS/400 system
Private Sub crtLib_Click()
  On Error GoTo failed

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus

  ' Call the Run method on the Command object to create the libary
  Else
    Screen.MousePointer = vbHourglass
    cmd.Run "crtlib " & libName.Text
    Screen.MousePointer = vbDefault
    MsgBox "Library created successfully"
  End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo cmd.Errors
  errInfo.Show vbModal
End Sub

' This routine deletes an existing data queue from the AS/400 system,
' using a DataQueue object
Private Sub dltDQ_Click()
  On Error GoTo failed

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus
  ElseIf (dqName.Text = "") Then
    MsgBox "Enter a queue name"
    dqName.SetFocus

  ' Call the Delete method, on the DataQueue object, to delete the queue
  Else
    Screen.MousePointer = vbHourglass
    If chkUseKeyed.Value = vbChecked Then
      kdq.Delete
    Else
      dq.Delete
    End If
    Screen.MousePointer = vbDefault
    MsgBox "Data queue deleted successfully"
  End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo dq.Errors
  errInfo.Show vbModal
End Sub

' This routine uses the Command object to delete an existing library
' from the AS/400 system
Private Sub dltLib_Click()
  On Error GoTo failed

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus

  ' Call the Run method on the Command object to delete the libary
  Else
    Screen.MousePointer = vbHourglass
    cmd.Run "dltlib " & libName.Text
    Screen.MousePointer = vbDefault
    MsgBox "Library deleted successfully"
  End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo cmd.Errors
  errInfo.Show vbModal
End Sub

' This routine uses the DataQueue and DataQueueAttributes objects to
' display the attributes of an existing data queue on the AS/400
Private Sub dqAttributes_Click()
  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus
  ElseIf (dqName.Text = "") Then
    MsgBox "Enter a queue name"
    dqName.SetFocus

  ' Display a dialog with the data queue attribute information
  Else
    If chkUseKeyed.Value = vbChecked Then
      Set dqAttrs.dq = kdq
    Else
      Set dqAttrs.dq = dq
    End If
    dqAttrs.Show vbModal
  End If
End Sub

' This routine updates the value of the QueueName property for the
' DataQueue object, whenever the user chooses a different queue name
Private Sub dqName_LostFocus()
  On Error GoTo failed

   If chkUseKeyed.Value = vbChecked Then
      If (dqName.Text <> kdq.QueueName) Then
         kdq.QueueName = dqName.Text
      End If

   Else
      If (dqName.Text <> dq.QueueName) Then
         dq.QueueName = dqName.Text
      End If
   End If

  Exit Sub
failed:
  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo dq.Errors
  errInfo.Show vbModal
End Sub

' This routine initializes the contents of the sytem names list, using
' the SystemNames object. It also sets up the AS400System object
' to access the default system
Private Sub Form_Load()
  On Error GoTo failed

  Dim as400Systems As New cwbx.SystemNames
  Dim systemName As Variant

  ' Populate the system names list using information from the SystemNames
  ' object
  For Each systemName In as400Systems
    sysNames.AddItem systemName
  Next

  ' Set the current selection to the default system
  sysNames.Text = UCase(as400Systems.DefaultSystem)

  ' Set up the AS400System object to access the default system and set
  ' the System property for the DataQueue, Program, and Command objects
  ' to this AS400System object
  If (sysNames.Text <> "") Then
    as400.Define sysNames.Text

    Set dq.System = as400
    Set kdq.System = as400
    Set pgm.System = as400
    Set cmd.System = as400
  End If

  Exit Sub
failed:
  ' If there is an error, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.Show vbModal
End Sub

' This routine updates the value of the LibraryName property for the
' DataQueue object, whenever the user chooses a different library name
Private Sub libName_LostFocus()
  On Error GoTo failed

  If (libName.Text <> dq.LibraryName) Then
    dq.LibraryName = libName.Text
    kdq.LibraryName = libName.Text
  End If

  Exit Sub
failed:
  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo dq.Errors
  errInfo.Show vbModal
End Sub

' This routine uses the DataQueue object to retrieve a record from the
' AS/400 data queue and displays the data, as a string, in an edit
' box.  The StringConverter object is used to convert the data from
' EBCDIC to Unicode.
Private Sub receive_Click()
  ' Create a StringConverter object for performing EBCDIC to Unicode
  ' conversion
  Dim strCvtr As New cwbx.StringConverter
  Dim bKey() As Byte

  On Error GoTo failed

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus
  ElseIf (dqName.Text = "") Then
    MsgBox "Enter a queue name"
    dqName.SetFocus

  ' Call the Read method of the DataQueue object to retrieve a record
  ' from the AS/400 data queue.  Use the FromBytes method of the
  ' StringConverter object, to convert the data from EBCDIC to Unicode
  Else
    Screen.MousePointer = vbHourglass
    If chkUseKeyed.Value = vbChecked Then
        'Keyed Data Queue
        'Keys are treated as binary but many people use text.  Note that
        'this can affect your search order if you use GT or LT on a key
        If InStr(1, txtKeyData.Text, "0x", vbTextCompare) > 0 Then
           'binary key so build byte array
           ReDim bKey(kdq.QueryAttributes.KeySize - 1) As Byte
           If HexString2Key(txtKeyData.Text, bKey()) Then _
              receiveData.Text = strCvtr.FromBytes(kdq.Read(bKey, cwbdqEqual, 10))
           Else
               'Treat the key as a string and convert it to EBCDIC text
               receiveData.Text = strCvtr.FromBytes( _
                     kdq.Read(strCvtr.ToBytes(txtKeyData.Text), cwbdqEqual, 10))
           End If
    Else
        'Nonkeyed
         receiveData.Text = strCvtr.FromBytes(dq.Read)
   End If
    Screen.MousePointer = vbDefault
  End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault
  receiveData.Text = ""
  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo dq.Errors
  errInfo.Show vbModal
End Sub

' This routine uses the AS400System object to display information about
' the selected AS/400 sytem
Private Sub retrieveSysInfo_Click()
  ' Validate input value
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus

  ' Display a dialog with the system information
  Else
    sysInfo.Show vbModal
  End If
End Sub

' This routine uses the DataQueue object to retrieve text from an edit box
' and to write it to an AS/400 data queue.  The StringConverter object is
' also used to convert the data from Unicode to EBCDIC.
Private Sub send_Click()
  ' Create a StringConverter object to perform Unicode to EBCDIC conversion
  Dim strCvtr As New cwbx.StringConverter
  Dim bKey() As Byte

  On Error GoTo failed

  ' Validate input values
  If (as400.systemName = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus
  ElseIf (libName.Text = "") Then
    MsgBox "Enter a library name"
    libName.SetFocus
  ElseIf (dqName.Text = "") Then
    MsgBox "Enter a queue name"
    dqName.SetFocus
  ElseIf (sendData.Text = "") Then
    MsgBox "Enter some text to send to the data queue"
    sendData.SetFocus

  ' Call the Write method of the DataQueue object to write the data
  ' to the AS/400 data queue.  Use the ToBytes method, of the
  ' StringConverter object, to convert the data from Unicode to EBCDIC.
  Else
     Screen.MousePointer = vbHourglass
     
     If chkUseKeyed.Value = vbChecked Then
        'Keyed Data Queue
        
        'Keys are usually binary but some people like to use string names
        If InStr(1, txtKeyData.Text, "0x", vbTextCompare) > 0 Then
           'binary so build byte array
           ReDim bKey(kdq.QueryAttributes.KeySize - 1) As Byte
           If HexString2Key(txtKeyData.Text, bKey()) Then _
              kdq.Write strCvtr.ToBytes(sendData.Text), bKey
        Else 'we'll treat the string as text and xlate it to EBCDIC
           kdq.Write strCvtr.ToBytes(sendData.Text), strCvtr.ToBytes(txtKeyData.Text)
        End If
     Else
        'Nonkeyed
         dq.Write strCvtr.ToBytes(sendData.Text)
    End If
    
    Screen.MousePointer = vbDefault
    sendData.Text = ""
  End If

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo dq.Errors
  errInfo.Show vbModal
End Sub

' This routine creates a new AS400System object, whenever
' the user chooses a different system name.  It also updates the
' System property of the DataQueue, Program, and Command objects
' to use the new AS/400 system.
Private Sub sysNames_LostFocus()
  On Error GoTo failed

  ' Validate input value
  If (sysNames.Text = "") Then
    MsgBox "Enter a system name"
    sysNames.SetFocus

  ' If the system named changed, create a new AS400System object
  ' and call the Define method to specify the system name
  ElseIf (sysNames.Text <> as400.systemName) Then
    Set as400 = New cwbx.AS400System
    as400.Define sysNames.Text

    ' Update the System property of the DataQueue, Program and
    ' Command objects
    Set dq.System = as400
    Set pgm.System = as400
    Set cmd.System = as400

    ' Reset the indicator for determining if we already created
    ' an AS/400 user space for this job
    userSpaceCreated = False
  End If

  Exit Sub
failed:
  ' If there was an error, use the Errors object to display a
  ' dialog with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo as400.Errors
  errInfo.Show vbModal
End Sub

Private Function HexString2Key(StringKey As String, Key() As Byte) As Boolean
'Convert hex number in string format to byte array
'INPUT:  String must be in the format of x00 where
'           x is upper or lowercase 'x' character
'           and 00 is a valid 2 DIGIT hex number      Ex: "xF0 xF0 xF0"
'OUTPUT: Byte array with values of string.            EX:   240 240 240
'                                                     EX: (EBCDIC) 111

   Dim I As Integer
   Dim j As Integer
   Dim S As String
   Dim c As Byte
   Dim LastByte As Integer       'posistion of last byte
   Dim StringNum As String       'holds 2 character hex number
   
   On Error GoTo HexString2KeyErr
   
   LastByte = 1
   For I = 0 To UBound(Key)
      LastByte = InStr(LastByte, StringKey, "x", 1)
      If LastByte = 0 Then
         GoTo HexString2KeyErr
      End If
      LastByte = LastByte + 1       'start one past it next time
      StringNum = Mid(StringKey, LastByte, 2)
      Key(I) = Val("&H" & StringNum)
   Next I
   
   HexString2Key = True
   Exit Function

HexString2KeyErr:
   MsgBox "Error converting String.  The Key should be in the format ""X00 "" for each byte.  For example a 3 byte key of EBCDIC 123 would be entered as: ""XF1 XF2 XF3"". " _
         , , "Error reading key"
   HexString2Key = False
End Function

