VERSION 5.00
Begin VB.Form errInfo 
   Caption         =   "Error Information"
   ClientHeight    =   4125
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7230
   LinkTopic       =   "Form1"
   ScaleHeight     =   4125
   ScaleWidth      =   7230
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton okBtn 
      Caption         =   "OK"
      Height          =   315
      Left            =   3240
      TabIndex        =   6
      Top             =   3720
      Width           =   855
   End
   Begin VB.ListBox caMessages 
      Height          =   1425
      Left            =   120
      TabIndex        =   4
      Top             =   2040
      Width           =   6975
   End
   Begin VB.Label Label1 
      Caption         =   "Client Access messages:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1800
      Width           =   3495
   End
   Begin VB.Label caRC 
      Caption         =   "Client Access return code:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   4455
   End
   Begin VB.Label errSource 
      Caption         =   "Error source:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   4455
   End
   Begin VB.Label errDesc 
      Caption         =   "Error description:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   6975
   End
   Begin VB.Label errNumber 
      Caption         =   "Error number:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4455
   End
End
Attribute VB_Name = "errInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' This routine terminates the dialog
Private Sub okBtn_Click()
  Unload Me
End Sub

' This routine displays information from the Visual Basic Err object
' in the dialog
Public Sub setVBInfo(vbErr As ErrObject)
Dim sDQRC As String

  
  errNumber.Caption = "Error number:  " & vbErr.Number
  errDesc.Caption = "Error description:  " & vbErr.Description
  errSource.Caption = "Error source:  " & vbErr.Source
  
  
  sDQRC = Mid(vbErr.Description, Len(vbErr.Description) - 3, 4)
  If Val(sDQRC) >= 6000 And Val(sDQRC) <= 6099 Then
      caMessages.AddItem sDQRC & ": " & vballobj.gDQHelper.GetRCText(Val(sDQRC))
  End If
End Sub

' This routine retrieves information from the Client Access Express Errors
' collection and displays it in the dialog
Public Sub setCWBInfo(cwbErrs As cwbx.Errors)
   Dim cwbErr As cwbx.Error
  ' Retrieve the Client Access return code
  caRC.Caption = "Client Access return code:  " & cwbErrs.ReturnCode

  ' Display any Client Access Messages returned
  For Each cwbErr In cwbErrs
    caMessages.AddItem cwbErr.Text
  Next
End Sub

